##### R scripts supplementary for
##### 'Divergence from, and convergence to, uniformity
##### of probability density quantiles' by Robert G. Staudte
##### and Aihua Xia,  22 February, 2018.


## The following scripts find iterates  f^{n*} for a given f^*
## Given a grid of equally spaced points u on (0,1), and 
## values of a pdQ f^*(u)
## the function f2star finds the next iterate f2star; 
## a plotting example follows below.

f2star <- function(u,fstar)
{lenu <- length(u)
inc <- 1/lenu
s <- numeric(0)
s[1] <- 0
for (j in 2:lenu){uj <- u[j]
s[j] <- s[j-1]+fstar[j]}
Fstar <- s*inc ############ this is the cdf F*
v <- u
Qstar <- u
for (j in 1:lenu){vj <- v[j]
Qstar[j] <- which.min(abs(vj-Fstar))/length(v)} ## quantile function Q^*

fstarQstar <- u
for (j in 1:length(v))
{ind  <- which.min(abs(v-Qstar[j]))
fstarQstar[j] <- fstar[ind]}   ###### density quantile f^*(Q^*)
kappastar <- inc*sum(fstarQstar)
f2star <- fstarQstar/kappastar   ###  f^{2*}
return(f2star)}

##############   Lognormal Example
##############   (the reader may easily modify this code to iterate
##############   other pdQs)

par(mex=.8,cex=1.1)

plotfnstar <- function(n,inc=.0001)
{u <- c(seq(inc/2,1-inc/2,inc))  ### Find grid of points 
fQ <- dlnorm(qlnorm(u))
kappa <- inc*sum(fQ)
fstar <- fQ/kappa                ### This is starting pdQ
plot(u,fstar,type="l",lwd=2,ylim=c(0,2),
ylab="f^{n*}(u)", main="Iterated Lognormal pdQ s")
fnstar <- fstar
for (j in 2:n)
{fnstar <- f2star(u,fnstar)
lines(u,fnstar)}}

plotfnstar(3)

########## WARNING: this procdure may lead to apparent convergence, 
########## but misleading results if fnstar does not exist,
########## such as with chi-sq with df <= 1. See the manuscript
########## for required conditions.